
Texture3D <float3> texVOL <string uiname="Volume";>;

SamplerState linearSampler <string uiname="Sampler State";>
{
	Filter = MIN_MAG_MIP_LINEAR;
	AddressU = WRAP;
	AddressV = WRAP;
};
float4x4 tVP : LAYERVIEWPROJECTION;
float4x4 tVI: VIEWINVERSE;
float4x4 tW : WORLD;
float4x4 tPI : PROJECTIONINVERSE;

float4x4 tVolumeTransform;

struct VS_IN
{
	float4 pos : POSITION;
	float4 uv : TEXCOORD0;
	
};

struct VS_OUT
{
	float4 pos: SV_Position;
	float4 uv: TEXCOORD0;
};

VS_OUT VS(VS_IN input)
{
	VS_OUT output;
	output.pos  = mul(input.pos,tW);
	output.uv = input.uv;
	return output;
}

//bool VVVVSpace = true;
uint maxSteps = 128;
float stepSize = .01;

float opacity = .001;
float boost = 1;
float gamma =1;
float offsetZ;

float3 UVtoEYE(float2 UV){
	
	//	float3 resultUVtoEYE =  normalize( mul(float4(mul(mul(float4((UV.xy*2-1)*float2(1,-1),0,1),tVolumeTransform),tPI).xy,1,0),tVI).xyz);
	
	float3 resultUVtoEYE =  normalize( mul(float4(mul(float4((UV.xy*2-1)*float2(1,-1),0,1),tPI).xy,1,0),tVI).xyz);
	return resultUVtoEYE;
	//	return mul(resultUVtoEYE,tVolumeTransform);
}

float3 volume(float3 p, Texture3D<float3> t){
	
	//	p = mul(tVolumeAspect,float4(p,1)).xyz;
	//	p = p+((1-VVVVSpace)*float3(0.5,0.5,0.5));
	
	//		p = mul(tVolumeTransform,float4(p,1)).xyz;
	
	p = mul(float4(p,1),tVolumeTransform).xyz;
	
	float3 result = t.SampleLevel(linearSampler,p,0);
	//	return abs(result);
	return result;
}

float hash1( in float2 f )
{
	return frac(sin(f.x+131.1*f.y)*43758.5453123);
}


float4 PS(VS_OUT input): SV_Target
{
	
	// Ray Origin
	float3 eye = tVI[3].xyz;
	
	// Ray Direction
	float3 dir = UVtoEYE(input.uv.xy);
	
	float3 p = eye + offsetZ*normalize(dir);
	
	float3 accumVolume;
	float3 lightP = p;
	
	for(uint i = 0; i <= maxSteps; i++){
		p += dir * stepSize ;
		accumVolume += volume(p,texVOL) * opacity;
		
	}
	
	float4 col;
	
	col= float4(accumVolume*boost,1);
	
	col.xyz=sign(col.xyz)*pow(abs(col.xyz),gamma);
	
	return col;
	
	
}





technique10 Constant
{
	pass P0
	{
		SetVertexShader( CompileShader( vs_4_0, VS() ) );
		SetPixelShader( CompileShader( ps_5_0, PS() ) );
	}
}